// jquery toggleAttr

jQuery.fn.toggleAttr = function(attr) {
	return this.each(function() {
		var $this = $(this);
		$this.attr(attr) ? $this.removeAttr(attr) : $this.attr(attr, attr);
	});
};

// nice alert function

function alertit(message,title){
	
	if(empty(title)) title = 'ALERT';
	
	var alert_box = '<div class="alert_overlay" id="alert_box">'
		+'<div class="alert_box">'
			+'<div class="alert_header">'+title+'</div>'
			+'<div class="alert_content">'
			+message
		+'</div>'
		+'<div class="alert_footer"><span class="alert_btn">OK</span></div>'
		+'</div>'
	+'</div>';
	
	jQuery('body').append(alert_box);
	jQuery('#alert_box .alert_btn').click(function(){
		jQuery('#alert_box').fadeOut(300,function(){
			jQuery(this).remove();
		});
	});
	
}

// htmlspecialchars for javascript

function escapeHtml(text) {
	var map = {
		'&': '&amp;',
		'<': '&lt;',
		'>': '&gt;',
		'"': '&quot;',
		"'": '&#039;'
	};
	return text.replace(/[&<>"']/g, function(m) {
		return map[m];
	});
}
// nice prompt function

function promptit(callback,message,title){
	
	if(empty(title)) message = 'Inserisci qui eventuali note da allegare al PDF.';
	if(empty(title)) title = 'NOTE PERSONALI';
	
	var alert_box = '<div class="alert_overlay" id="alert_box">'
		+'<div class="alert_box">'
			+'<div class="alert_header">'+title+'</div>'
			+'<div class="alert_content">'
			+message
		+'<br><br><textarea id="notesTextarea" cols="10" rows="5" class="form-control"></textarea>'
		+'</div>'
		+'<div class="alert_footer"><span class="alert_btn">OK</span></div>'
		+'</div>'
	+'</div>';
	
	jQuery('body').append(alert_box);
	jQuery('#alert_box .alert_btn').click(function(){
		text = jQuery('#notesTextarea').val();
		jQuery('#alert_box').fadeOut(300,function(){
			jQuery(this).remove();
		});
		if(callback && typeof callback === "function") return callback(text);
	});
	
}

// function empty()

function empty(mixed_var) {
	var undef, key, i, len;
	var emptyValues = [undef, null, false, 0, '', '0'];
	for (i = 0, len = emptyValues.length; i < len; i++) {
		if (mixed_var === emptyValues[i]) {
			return true;
		}
	}
	if (typeof mixed_var === 'object') {
		for (key in mixed_var) {
			return false;
		}
		return true;
	}
	return false;
}

// function to find closest number in array of numbers

function find_closest(num, arr) {
	var curr = arr[0];
	arr.forEach(function(val) {
		if (Math.abs(num - val) < Math.abs(num - curr)) curr = val;
	});
	return curr;
}

// function in_array()

function in_array(needle, haystack) {
    var length = haystack.length;
    for(var i = 0; i < length; i++) {
        if(haystack[i] == needle) return true;
    }
    return false;
}

// funzione di pulizia della variabile numerica

function get_number(value){
	
	value = parseFloat(value.replace(',','.').replace(' ',''));
	value = parseFloat(value.toFixed(2));
	
	return value;
	
}

// funzione di conversione inch to mm

function inch2mm(inch,num,den){
	
	if(isNaN(inch)) var inch = 0; else var inch = parseFloat(inch);
	if(isNaN(num)) var num = 0; else var num = parseFloat(num);
	if(isNaN(den)) var den = 32; else var den = parseFloat(den);
	
	var float_inch = inch + (1/den*num);
	var mm = float_inch * 25.4;
	
	return mm.toFixed(2);
		
}

// funzione di conversione mm to inch

function mm2inch(mm){
	
	if(isNaN(mm)) var mm = 0; var mm = parseFloat(mm);
	
	var float_inch = mm * 0.039370;
	
	return float_inch.toFixed(2);
		
}

// funzione di conversione libbre in kg

function lb2kg(lb){
	
	if(isNaN(lb)) var lb = 0; var lb = parseFloat(lb);
	
	var float_kg = lb * 0.453592;
	
	return float_kg.toFixed(2);
		
}

// funzione di conversione kg in libre

function kg2lb(kg){
	
	if(isNaN(kg)) var kg = 0; var kg = parseFloat(kg);
	
	var float_lb = kg * 2.20462;
	
	return float_lb.toFixed(2);
		
}

// funzione di conversione densità da kg/m3 a lb/ft3

function kgm2lbft(dens){
	
	if(isNaN(dens)) var dens = 0; var dens = parseFloat(dens);
	
	var float_dens = dens * 0.06242796;
	
	return float_dens.toFixed(2);
		
}

// funzione di conversione densità da kg/m3 a lb/ft3

function lbft2kgm(dens){
	
	if(isNaN(dens)) var dens = 0; var dens = parseFloat(dens);
	
	var float_dens = dens * 16.018463;
	
	return float_dens.toFixed(2);
		
}

// funzione di conversione floatinch to fractioned inch (massimo 32esimi)

function inch2frac(inch){
	
	//console.log("calcolo "+inch);

	if(isNaN(inch)) var inch = 0; else var inch = parseFloat(inch);

	var int_inch = parseInt(inch);
	var rem_inch = inch - int_inch;
	
	//console.log("il resto è "+rem_inch.toFixed(4));
	
	if(!rem_inch) return [int_inch,0,32];
	
	var denominators = [32,16,8,4,2];
	var precision_error = 999;
	var num = 0;
	var den = 32;
	
	denominators.forEach(function(this_den){
		
		// provo ogni denominatore trovandone il numeratore
		// il corretto numeratore è un intero >= 1
		// la frazione più precisa è quella il cui risultato è più vicino al resto originale

		var this_numerator = Math.round(rem_inch * this_den);
		//console.log("corrisponde a "+this_numerator+"/"+this_den);
		
		var this_fraction_result = int_inch + ( 1 / this_den * this_numerator );
		//console.log("il cui risultato è "+this_fraction_result.toFixed(4));
		
		var this_precision = Math.abs( inch - this_fraction_result );
		//console.log("l'errore di scarto è "+this_precision );

		if( this_precision <= precision_error && this_numerator >= 1 ){
			precision_error = this_precision;
			num = this_numerator;
			den = this_den;
		}
		
	});
	
	return [int_inch,num,den];
	
}

function output_number(value,type){
	
	// global $unita_di_misura
	
	if(isNaN(value)) var value = 0; else var value = parseFloat(value);
	if(isNaN(value) || !in_array(type,['lunghezza','peso','densita'])) return false;
	
	if(unita_di_misura == 'imp'){
		
		if(type == 'lunghezza'){
			value = mm2inch(value);
			fraction_value = inch2frac(value);
			if(!empty(fraction_value[1])) value = fraction_value[0]+'" <sup>'+fraction_value[1]+'</sup>&frasl;<sub>'+fraction_value[2]+'</sub>';
			var udm = ' in';
		}
		
		if(type == 'peso'){
			value = kg2lb(value);
			var udm = ' lb';
		}
		
		if(type == 'densita'){
			value = kgm2lbft(value);
			var udm = ' lb/ft<sup>3</sup>';
		}
		
		return value+udm;

	}else{
	
		if(type == 'lunghezza') var udm = ' mm';
		if(type == 'peso') var udm = ' Kg';
		if(type == 'densita') var udm = ' Kg/m<sup>3</sup>';
		
		return value+udm;
	
	}
	
}

function switch_udm(to_udm){
	
	if(!in_array(to_udm,['dec','imp'])) return false;

	unita_di_misura = to_udm;
	
	// show complex inputs
	
	jQuery('.calc_input').each(function(){
		
		if( jQuery(this).hasClass('calc_lunghezza') ){
			
			if(unita_di_misura == 'imp'){
				var misura_attuale_convertita = inch2frac(mm2inch(get_number(jQuery(this).find('input').first().val())));
				var input_name = jQuery(this).find('input').attr('name');
				var fraction_inputs = '<span class="imperial"><input type="text" pattern="[0-9]*" name="'+input_name+'_imp" class="form-control imperial" style="width:30%;" value="'+misura_attuale_convertita[0]+'"> " &nbsp; <input type="text" pattern="[0-9]*" name="'+input_name+'_num" class="form-control imperial" style="width:20%;" placeholder="0" value="'+misura_attuale_convertita[1]+'"> / <input type="text" pattern="[2,4,8,16,32]" name="'+input_name+'_den" class="form-control imperial" style="width:20%;" placeholder="32" value="'+misura_attuale_convertita[2]+'"></span>';
				jQuery(this).find('input').hide().after(fraction_inputs);
				jQuery(this).find('.udm').html('in');
			}else{
				jQuery(this).find('input').show();
				jQuery(this).find('.imperial').remove();
				jQuery(this).find('.udm').html('mm');
			}
			
		}else if( jQuery(this).hasClass('calc_peso') ){
						
			if(unita_di_misura == 'imp'){
				var misura_attuale_convertita = kg2lb(get_number(jQuery(this).find('input').first().val()));
				var input_name = jQuery(this).find('input').attr('name');
				var fraction_inputs = '<input type="text" pattern="[0-9]*" name="'+input_name+'_imp" class="form-control imperial" style="width:80%;" value="'+misura_attuale_convertita+'">';
				jQuery(this).find('input').hide().after(fraction_inputs);
				jQuery(this).find('.udm').html('lb');
			}else{
				jQuery(this).find('input').show();
				jQuery(this).find('input.imperial').remove();
				jQuery(this).find('.udm').html('Kg');
			}

		}else if( jQuery(this).hasClass('calc_densita') ){
			
			if(unita_di_misura == 'imp'){
				var misura_attuale_convertita = kgm2lbft(get_number(jQuery(this).find('input').first().val()));
				var input_name = jQuery(this).find('input').attr('name');
				var fraction_inputs = '<input type="text" pattern="[0-9]*" name="'+input_name+'_imp" class="form-control imperial" style="width:80%;" value="'+misura_attuale_convertita+'">';
				jQuery(this).find('input').hide().after(fraction_inputs);
				jQuery(this).find('.udm').html('lb/ft<sup>3</sup>');
			}else{
				jQuery(this).find('input').show();
				jQuery(this).find('input.imperial').remove();
				jQuery(this).find('.udm').html('Kg/m<sup>3</sup>');
			}

		}
		
	});
	
	// bind input changes
	
	if(unita_di_misura == 'imp'){
		
		jQuery(document).on('change keyup focusout','input.imperial',function(obj){
			
			// se è frazionato
			if(jQuery(this).parents('.calc_lunghezza').length){

				var imp = get_number(jQuery(this).closest('.calc_input').find('[name*="_imp"]').val());
				var num = get_number(jQuery(this).closest('.calc_input').find('[name*="_num"]').val());
				var den = get_number(jQuery(this).closest('.calc_input').find('[name*="_den"]').val());

				jQuery(this).closest('.calc_input').find('input').first().val(inch2mm(imp,num,den)).change();
				
			}else if(jQuery(this).parents('.calc_peso').length){
				
				var lb = get_number(jQuery(this).val());
				jQuery(this).siblings('input').first().val(lb2kg(lb)).change();

			}else if(jQuery(this).parents('.calc_densita').length){

				var dens = get_number(jQuery(this).val());
				jQuery(this).siblings('input').first().val(lbft2kgm(dens)).change();
				
			}
			
			// aggiorno il peso calcolato
			
			var altezza = get_number(jQuery('[name="altezza"]').val());
			var larghezza = get_number(jQuery('[name="larghezza"]').val());
			var profondita = get_number(jQuery('[name="profondita"]').val());
			var densita = get_number(jQuery('[name="densita"]').val());
			
			if( jQuery('.material_selection').is(':visible') ){
				var peso = altezza * larghezza * profondita * densita / 1000000000;
				peso = peso.toFixed(2);
				if(!isNaN(peso)) jQuery('input[name="peso"]').val(peso).change();
				else jQuery('input[name="peso"]').val('');
			}
			
			var kg = get_number(jQuery('[name="peso"]').val());
			jQuery('[name="peso_imp"]').val(kg2lb(kg));

		});

		jQuery(document).on('click','#material_buttons',function(obj){
			
			var dens = get_number(jQuery('[name="densita"]').val());
			jQuery('[name="densita_imp"]').val(kgm2lbft(dens)).change();
			
		});
		
	}else{
		
		jQuery(document).off('change keyup focusout','input.imperial');
		jQuery(document).off('click','#material_buttons');
		
	}
	
	// correzioni di testo
	
	if(unita_di_misura == 'imp'){

		jQuery('.text_mat1').html("40 lb/ft<sup>3</sup>");
		jQuery('.text_mat2').html("32 lb/ft<sup>3</sup>");
		jQuery('.text_mat3').html("48 lb/ft<sup>3</sup>");
		
	}else{
		
		jQuery('.text_mat1').html("650 Kg/m<sup>3</sup>");
		jQuery('.text_mat2').html("520 Kg/m<sup>3</sup>");
		jQuery('.text_mat3').html("780 Kg/m<sup>3</sup>");
		
	}
	
	// toggle switch button
	
	jQuery('.menu_switch').find('span').removeClass('active');
	jQuery('.menu_switch').find('.udm_'+to_udm).addClass('active');
	
	// update summary
	
	updateSummary();
		
}



















